#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QGroupBox>
#include <QListWidget>

#include <limits>
#include <stdint.h>

#include "iopanel.h"

#include "intarroutput.h"
#include "intarrinput.h"

#include "intinput.h"
#include "intoutput.h"

#include "floatinput.h"
#include "floatoutput.h"

#include "floatarrinput.h"
#include "floatarroutput.h"

#include "container.h"

#include "iopanel.h"

#include "ivm.h"

namespace Ui {
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    QListWidget *log;

    Container *MainContainer;

    void AddIOPanel(iopanel* Panel);

    void logAdd(QString str);
    void logClear();

    QLineEdit *comedit;

    device_t device;

    /* iopanels for commands
     * THIS CODE IS AUTOGENERATED
     */

    

    


    // command get_measurement
    iopanel* get_measurementiop;

    // req arguments
    // argument FrameNumber type ('uint16_t', '')
        IntInput* get_measurementFrameNumberinputwidget;
    
    // resp arguments
    // argument Voltage type ('float', '[25]')
    
    FloatArrOutput* get_measurementVoltageoutputwidget;
    
    // argument Current type ('float', '[25]')
    
    FloatArrOutput* get_measurementCurrentoutputwidget;
    

    // command get_identity_information
    iopanel* get_identity_informationiop;

    // req arguments
    // resp arguments
    // argument Manufacturer type ('uint8_t', '[16]')
    
    IntArrOutput* get_identity_informationManufactureroutputwidget;
    
    // argument ProductName type ('uint8_t', '[16]')
    
    IntArrOutput* get_identity_informationProductNameoutputwidget;
    
    // argument ControllerName type ('uint8_t', '[16]')
    
    IntArrOutput* get_identity_informationControllerNameoutputwidget;
    
    // argument HardwareMajor type ('uint8_t', '')
    
    IntOutput* get_identity_informationHardwareMajoroutputwidget;
    
    // argument HardwareMinor type ('uint8_t', '')
    
    IntOutput* get_identity_informationHardwareMinoroutputwidget;
    
    // argument HardwareBugfix type ('uint16_t', '')
    
    IntOutput* get_identity_informationHardwareBugfixoutputwidget;
    
    // argument BootloaderMajor type ('uint8_t', '')
    
    IntOutput* get_identity_informationBootloaderMajoroutputwidget;
    
    // argument BootloaderMinor type ('uint8_t', '')
    
    IntOutput* get_identity_informationBootloaderMinoroutputwidget;
    
    // argument BootloaderBugfix type ('uint16_t', '')
    
    IntOutput* get_identity_informationBootloaderBugfixoutputwidget;
    
    // argument FirmwareMajor type ('uint8_t', '')
    
    IntOutput* get_identity_informationFirmwareMajoroutputwidget;
    
    // argument FirmwareMinor type ('uint8_t', '')
    
    IntOutput* get_identity_informationFirmwareMinoroutputwidget;
    
    // argument FirmwareBugfix type ('uint16_t', '')
    
    IntOutput* get_identity_informationFirmwareBugfixoutputwidget;
    
    // argument SerialNumber type ('uint32_t', '')
    
    IntOutput* get_identity_informationSerialNumberoutputwidget;
    
    // argument Reserved type ('uint8_t', '[8]')
    
    IntArrOutput* get_identity_informationReservedoutputwidget;
    

    // command start_autocalibration
    iopanel* start_autocalibrationiop;

    // req arguments
    // resp arguments
    // argument Result type ('uint8_t', '')
    
    IntOutput* start_autocalibrationResultoutputwidget;
    

    // command get_status
    iopanel* get_statusiop;

    // req arguments
    // resp arguments
    // argument Status type ('uint32_t', '')
    
    IntOutput* get_statusStatusoutputwidget;
    
    // argument Temp type ('int16_t', '')
    
    IntOutput* get_statusTempoutputwidget;
    
    // argument Reserved type ('uint8_t', '[48]')
    
    IntArrOutput* get_statusReservedoutputwidget;
    

    // command get_measurement_settings
    iopanel* get_measurement_settingsiop;

    // req arguments
    // resp arguments
    // argument SamplingRate type ('float', '')
    
    FloatOutput* get_measurement_settingsSamplingRateoutputwidget;
    
    // argument ProbeSignalFrequency type ('float', '')
    
    FloatOutput* get_measurement_settingsProbeSignalFrequencyoutputwidget;
    
    // argument NumberPoints type ('uint32_t', '')
    
    IntOutput* get_measurement_settingsNumberPointsoutputwidget;
    
    // argument NumberChargePoints type ('uint32_t', '')
    
    IntOutput* get_measurement_settingsNumberChargePointsoutputwidget;
    
    // argument MaxVoltage type ('float', '')
    
    FloatOutput* get_measurement_settingsMaxVoltageoutputwidget;
    
    // argument Reserved0 type ('uint8_t', '[4]')
    
    IntArrOutput* get_measurement_settingsReserved0outputwidget;
    
    // argument CurrentSensorMode type ('uint32_t', '')
    
    IntOutput* get_measurement_settingsCurrentSensorModeoutputwidget;
    
    // argument OutputMode type ('uint8_t', '')
    
    IntOutput* get_measurement_settingsOutputModeoutputwidget;
    
    // argument Reserved1 type ('uint8_t', '[19]')
    
    IntArrOutput* get_measurement_settingsReserved1outputwidget;
    

    // command set_measurement_settings
    iopanel* set_measurement_settingsiop;

    // req arguments
    // argument SamplingRate type ('float', '')
        FloatInput* set_measurement_settingsSamplingRateinputwidget;
    
    // argument ProbeSignalFrequency type ('float', '')
        FloatInput* set_measurement_settingsProbeSignalFrequencyinputwidget;
    
    // argument NumberPoints type ('uint32_t', '')
        IntInput* set_measurement_settingsNumberPointsinputwidget;
    
    // argument NumberChargePoints type ('uint32_t', '')
        IntInput* set_measurement_settingsNumberChargePointsinputwidget;
    
    // argument MaxVoltage type ('float', '')
        FloatInput* set_measurement_settingsMaxVoltageinputwidget;
    
    // argument Reserved0 type ('uint8_t', '[4]')
        IntArrInput* set_measurement_settingsReserved0inputwidget;
    
    // argument CurrentSensorMode type ('uint32_t', '')
        IntInput* set_measurement_settingsCurrentSensorModeinputwidget;
    
    // argument OutputMode type ('uint8_t', '')
        IntInput* set_measurement_settingsOutputModeinputwidget;
    
    // argument Reserved1 type ('uint8_t', '[19]')
        IntArrInput* set_measurement_settingsReserved1inputwidget;
    
    // resp arguments

    // command start_measurement
    iopanel* start_measurementiop;

    // req arguments
    // resp arguments

    // command check_measurement_status
    iopanel* check_measurement_statusiop;

    // req arguments
    // resp arguments
    // argument ReadyStatus type ('uint8_t', '')
    
    IntOutput* check_measurement_statusReadyStatusoutputwidget;
    
    // argument Reserved type ('uint8_t', '[15]')
    
    IntArrOutput* check_measurement_statusReservedoutputwidget;
    

    // command get_calibration_settings
    iopanel* get_calibration_settingsiop;

    // req arguments
    // resp arguments
    // argument Reserved0 type ('uint8_t', '[8]')
    
    IntArrOutput* get_calibration_settingsReserved0outputwidget;
    
    // argument ADCMult type ('float', '')
    
    FloatOutput* get_calibration_settingsADCMultoutputwidget;
    
    // argument ADCVOffset type ('float', '')
    
    FloatOutput* get_calibration_settingsADCVOffsetoutputwidget;
    
    // argument CurrentSense1Mult type ('float', '')
    
    FloatOutput* get_calibration_settingsCurrentSense1Multoutputwidget;
    
    // argument CurrentSense1Offset type ('float', '')
    
    FloatOutput* get_calibration_settingsCurrentSense1Offsetoutputwidget;
    
    // argument CurrentSense2Mult type ('float', '')
    
    FloatOutput* get_calibration_settingsCurrentSense2Multoutputwidget;
    
    // argument CurrentSense2Offset type ('float', '')
    
    FloatOutput* get_calibration_settingsCurrentSense2Offsetoutputwidget;
    
    // argument CurrentSense3Mult type ('float', '')
    
    FloatOutput* get_calibration_settingsCurrentSense3Multoutputwidget;
    
    // argument CurrentSense3Offset type ('float', '')
    
    FloatOutput* get_calibration_settingsCurrentSense3Offsetoutputwidget;
    
    // argument Reserved1 type ('uint8_t', '[72]')
    
    IntArrOutput* get_calibration_settingsReserved1outputwidget;
    

    // command set_calibration_settings
    iopanel* set_calibration_settingsiop;

    // req arguments
    // argument Reserved0 type ('uint8_t', '[8]')
        IntArrInput* set_calibration_settingsReserved0inputwidget;
    
    // argument ADCMult type ('float', '')
        FloatInput* set_calibration_settingsADCMultinputwidget;
    
    // argument ADCVOffset type ('float', '')
        FloatInput* set_calibration_settingsADCVOffsetinputwidget;
    
    // argument CurrentSense1Mult type ('float', '')
        FloatInput* set_calibration_settingsCurrentSense1Multinputwidget;
    
    // argument CurrentSense1Offset type ('float', '')
        FloatInput* set_calibration_settingsCurrentSense1Offsetinputwidget;
    
    // argument CurrentSense2Mult type ('float', '')
        FloatInput* set_calibration_settingsCurrentSense2Multinputwidget;
    
    // argument CurrentSense2Offset type ('float', '')
        FloatInput* set_calibration_settingsCurrentSense2Offsetinputwidget;
    
    // argument CurrentSense3Mult type ('float', '')
        FloatInput* set_calibration_settingsCurrentSense3Multinputwidget;
    
    // argument CurrentSense3Offset type ('float', '')
        FloatInput* set_calibration_settingsCurrentSense3Offsetinputwidget;
    
    // argument Reserved1 type ('uint8_t', '[72]')
        IntArrInput* set_calibration_settingsReserved1inputwidget;
    
    // resp arguments

    // command get_measurement_raw
    iopanel* get_measurement_rawiop;

    // req arguments
    // argument Frame type ('uint16_t', '')
        IntInput* get_measurement_rawFrameinputwidget;
    
    // resp arguments
    // argument ADCHighCode type ('uint16_t', '[25]')
    
    IntArrOutput* get_measurement_rawADCHighCodeoutputwidget;
    
    // argument ADCLowCode type ('uint16_t', '[25]')
    
    IntArrOutput* get_measurement_rawADCLowCodeoutputwidget;
    

    // command get_device_rank
    iopanel* get_device_rankiop;

    // req arguments
    // resp arguments
    // argument Rank type ('uint32_t', '')
    
    IntOutput* get_device_rankRankoutputwidget;
    
    // argument Reserved0 type ('uint8_t', '[128]')
    
    IntArrOutput* get_device_rankReserved0outputwidget;
    




public slots:
    void connectButton();
    void dconnectButton();

    void SearchSlot(QString str);

    void GetProfileSlot();
    void SetProfileSlot();

    /* slots for buttons
     * THIS CODE IS AUTOGENERATED
     */

    void get_measurementPressSlot(bool);

    void get_identity_informationPressSlot(bool);

    void start_autocalibrationPressSlot(bool);

    void get_statusPressSlot(bool);

    void get_measurement_settingsPressSlot(bool);

    void set_measurement_settingsPressSlot(bool);

    void set_measurement_settingsCallGetterPressSlot(bool);
    void start_measurementPressSlot(bool);

    void check_measurement_statusPressSlot(bool);

    void get_calibration_settingsPressSlot(bool);

    void set_calibration_settingsPressSlot(bool);

    void set_calibration_settingsCallGetterPressSlot(bool);
    void get_measurement_rawPressSlot(bool);

    void get_device_rankPressSlot(bool);


private:
    Ui::MainWindow *ui;
};

#endif // MAINWINDOW_H
